package awesomespeedometerwrapper;

import com.github.anastr.speedviewlib.AwesomeSpeedometer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;


import java.util.ArrayList;
import java.util.List;

import android.os.Bundle;



@ActivityObject
@Author("Github: Anas Altair, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("AwesomeSpeedometer")
public class awesomespeedometerWrapper extends ViewWrapper<AwesomeSpeedometer> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private AwesomeSpeedometer cv;
	


	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new AwesomeSpeedometer(ba.context);
        this.setObject(cv);

 	}
	
	
    public void setSpeedometerColor(int speedometerColor) {
        cv.setSpeedometerColor(speedometerColor);
        cv.invalidate();
    }


    public void setTrianglesColor(int trianglesColor) {
        cv.setTrianglesColor(trianglesColor);
        cv.invalidate();
    }

/*     public void setIndicatorWidth(float indicatorWidth) {
        cv.setIndicatorWidth(indicatorWidth);
        cv.invalidate();
    } */

/*     public void setLowSpeedColor(int lowSpeedColor) {
		cv.setLowSpeedColor(lowSpeedColor);
		cv.invalidate();
    }


    public void setMediumSpeedColor(int mediumSpeedColor) {
		cv.setMediumSpeedColor(mediumSpeedColor);
		cv.invalidate();
    }

    public void setHighSpeedColor(int highSpeedColor) {
		cv.setHighSpeedColor(highSpeedColor);
    }	 */
	
	
	
	
	
    /**
     * change speed to percent value.
     * percent percent value to change, should be between [0,100].
     */
    public void speedPercentTo(int percent) {
        cv.speedPercentTo(percent);
		cv.invalidate();
    }

    /**
     * if speed is less than 0 then speed will be 0.
     * speed correct speed to move.
     */
    public void speedTo_1(int speed) {
        cv.speedTo(speed);
		cv.invalidate();
    }

    /**
     * speed correct speed to move.
     * moveDuration The length of the animation, in milliseconds. This value cannot be negative.
     */
    public void speedTo_2(int speed, long moveDuration) {
        cv.speedTo(speed,moveDuration);
    }


    public void setSpeedometerWidth(float speedometerWidth) {
        cv.setSpeedometerWidth(speedometerWidth);
        cv.invalidate();
    }


/*     public void setWithTremble(boolean withTremble) {
        cv.setWithTremble(withTremble);
        cv.invalidate();
    } */


    public void setMaxSpeed(int maxSpeed) {
        cv.setMaxSpeed(maxSpeed);
        cv.invalidate();
    }


    public void setSpeedTextSize(float speedTextSize) {
        cv.setSpeedTextSize(speedTextSize);
        cv.invalidate();
    }


    public void setIndicatorColor(int indicatorColor) {
        cv.setIndicatorColor(indicatorColor);
        cv.invalidate();
    }


/*     public void setCenterCircleColor(int centerCircleColor) {
        cv.setCenterCircleColor(centerCircleColor);
        cv.invalidate();
    } */


    public void setMarkColor(int markColor) {
        cv.setMarkColor(markColor);
        cv.invalidate();
    }


    public void setTextColor(int textColor) {
        cv.setTextColor(textColor);
        cv.invalidate();
    }	

    public void setUnit(String unit) {
        cv.setUnit(unit);
        cv.invalidate();
    }	
	
	
    public void setSpeedTextColor(int speedTextColor) {
        cv.setSpeedTextColor(speedTextColor);
        cv.invalidate();
    }	
	
	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
	
   
}
